diff -urNX /home/leigh/.diffex prev_linuxppc_2_4_devel-2.4.19-local/arch/ppc/boot/prep/misc.c linuxppc_2_4_devel-2.4.19-local/arch/ppc/boot/prep/misc.c
--- prev_linuxppc_2_4_devel-2.4.19-local/arch/ppc/boot/prep/misc.c	2003-03-30 17:29:21.000000000 +0100
+++ linuxppc_2_4_devel-2.4.19-local/arch/ppc/boot/prep/misc.c	2003-03-30 17:29:28.000000000 +0100
@@ -109,13 +109,72 @@
 }
 #endif /* CONFIG_VGA_CONSOLE */
 
+void
+read_args(void)
+{
+	int timer = 0;
+	char *cp, ch;
+
+	puts("\nLinux/PPC load: ");
+	cp = cmd_line;
+	while ( *cp )
+		putc(*cp++);
+
+	while (timer++ < 5*1000) {
+		if (tstc()) {
+			while ((ch = getc()) != '\n' && ch != '\r') {
+				/* Test for backspace/delete */
+				if (ch == '\b' || ch == '\177') {
+					if (cp != cmd_line) {
+						cp--;
+						puts("\b \b");
+					}
+				/* Test for ^x/^u (and wipe the line) */
+				} else if (ch == '\030' || ch == '\025') {
+					while (cp != cmd_line) {
+						cp--;
+						puts("\b \b");
+					}
+				} else {
+					*cp++ = ch;
+					putc(ch);
+				}
+			}
+			break;  /* Exit 'timer' loop */
+		}
+		udelay(1000);  /* 1 msec */
+	}
+	*cp = 0;
+
+	puts("\n");
+}
+
+void
+get_of_args(void)
+{
+	int size;
+	phandle chosen;
+	char buf[256];
+
+	/* Get bootargs property of /chosen node */
+	chosen = finddevice("/chosen");
+
+	if (chosen != OF_INVALID_HANDLE) {
+		size = getprop(chosen, "bootargs", buf, sizeof(buf));
+
+		if (size > sizeof(cmd_buf))
+			size = sizeof(cmd_buf);
+
+		if (size > 1) /* includes null-terminator */
+			memcpy(cmd_buf, buf, size);
+	}
+}
+
 unsigned long
 decompress_kernel(unsigned long load_addr, int num_words, unsigned long cksum,
 		  RESIDUAL *residual, void *promptr)
 {
-	int timer = 0;
 	extern unsigned long start;
-	char *cp, ch;
 	unsigned long TotalMemory;
 	unsigned char board_type;
 	unsigned char base_mod;
@@ -256,36 +315,14 @@
 	if (keyb_present)
 		CRT_tstc();  /* Forces keyboard to be initialized */
 
-	puts("\nLinux/PPC load: ");
-	cp = cmd_line;
-	while ( *cp )
-		putc(*cp++);
-	while (timer++ < 5*1000) {
-		if (tstc()) {
-			while ((ch = getc()) != '\n' && ch != '\r') {
-				/* Test for backspace/delete */
-				if (ch == '\b' || ch == '\177') {
-					if (cp != cmd_line) {
-						cp--;
-						puts("\b \b");
-					}
-				/* Test for ^x/^u (and wipe the line) */
-				} else if (ch == '\030' || ch == '\025') {
-					while (cp != cmd_line) {
-						cp--;
-						puts("\b \b");
-					}
-				} else {
-					*cp++ = ch;
-					putc(ch);
-				}
-			}
-			break;  /* Exit 'timer' loop */
-		}
-		udelay(1000);  /* 1 msec */
-	}
-	*cp = 0;
-	puts("\nUncompressing Linux...");
+	/* If we have OF then try to get args from there */
+	if (promptr)
+		get_of_args();
+
+	/* Always give an opportunity to change the arguments */
+	read_args();
+
+	puts("Uncompressing Linux...");
 
 	/*
 	 * If we have OF, then we have deferred setting the MSR.
